<template>
    <div
        :key="listKeyAnswer[index]"
        v-for="(answer, index) in listAnswer"
        class="flex items-center border-b bg-gray-100"
    >
        <div class="w-36 flex items-center justify-center gap-3">
            <span>{{ String.fromCharCode(65 + index) }}</span>
            <div v-if="isMultiChoose" class="checkbox-custom">
                <input
                    :id="`key-${index}`"
                    type="checkbox"
                    v-model="answerChecked"
                    :value="index"
                    :checked="answer.right === QUIZ_CHECKED"
                />
                <label :for="`key-${index}`">&nbsp;</label>
            </div>
            <div v-else class="radio-custom">
                <input
                    :id="`right-${index}`"
                    type="radio"
                    v-model="answerChecked"
                    :value="index"
                    :checked="answer.right === QUIZ_CHECKED"
                />
                <label :for="`right-${index}`">&nbsp;</label>
            </div>
        </div>
        <div class="flex-1 flex items-center gap-3 p-3 border-l bg-white">
            <div class="flex-1">
                <QuillEditor v-model:content="answer.key" height="150" />
                <div
                    v-if="errors[index]"
                    class="text-left text-sm text-red-500 mt-1"
                >
                    {{ errors[index] }}
                </div>
            </div>
            <button
                @click="onRemoveAnswer(index)"
                v-tooltip="'Xóa'"
                type="button"
                class="w-8 h-8 text-center rounded-full border border-color-danger"
            >
                <XIcon class="w-5 h-8 mx-auto text-color-danger" />
            </button>
        </div>
    </div>

    <div class="p-5">
        <BasicButton
            @click="onAddAnswer"
            classCustom="bg-color-warning hover:shadow-hover-warning"
        >
            <PlusCircleIcon class="text-white" />
            Thêm đáp án
        </BasicButton>
    </div>
</template>

<script>
import { onMounted, ref, watch } from "vue";
import { QUIZ_NOT_CHECKED, QUIZ_CHECKED } from "@/constants";

import { XIcon, PlusCircleIcon } from "@heroicons/vue/outline";
import QuillEditor from "@/components/quill-editor/QuillEditorVue3.vue";
import BasicButton from "@/components/button/BasicButton.vue";

export default {
    components: {
        XIcon,
        PlusCircleIcon,
        QuillEditor,
        BasicButton
    },
    props: {
        answers: {
            type: Array,
            required: true
        },
        errors: {
            type: Array,
            required: true
        },
        isMultiChoose: {
            type: Boolean,
            default: false
        }
    },
    setup(props, context) {
        const listAnswer = ref(props.answers);
        const listKeyAnswer = ref([]); // tạo key để re-render quill-editor
        const answerChecked = ref(props.isMultiChoose ? [] : "");

        if (!listAnswer.value.length) {
            for (let i = 0; i < 4; i++) {
                listAnswer.value.push({
                    key: "",
                    right: QUIZ_NOT_CHECKED
                });
                listKeyAnswer.value.push(`answer-${i}`);
            }
        } else {
            for (let i = 0; i < listAnswer.value.length; i++) {
                listKeyAnswer.value.push(`answer-${i}`);
                if (listAnswer.value[i].right === QUIZ_CHECKED) {
                    if (props.isMultiChoose) {
                        answerChecked.value.push(i);
                    } else {
                        answerChecked.value = i;
                    }
                }
            }
        }

        onMounted(() => {
            context.emit("update:answers", listAnswer.value);
        });

        watch(answerChecked, newValue => {
            // reset select answer
            listAnswer.value = listAnswer.value.map(answer => {
                return { ...answer, right: QUIZ_NOT_CHECKED };
            });

            if (props.isMultiChoose) {
                for (const item of newValue) {
                    listAnswer.value[item].right = QUIZ_CHECKED;
                }
            } else if (newValue) {
                listAnswer.value[newValue].right = QUIZ_CHECKED;
            }
        });

        watch(listAnswer, newValue => {
            context.emit("update:answers", newValue);
        });

        // watch từng item trong listAnswer
        for (let i = 0; i < listAnswer.value.length; i++) {
            watch(listAnswer.value[i], newValue => {
                const copyListAnswer = [...listAnswer.value];
                copyListAnswer.splice(i, 1, newValue);
                listAnswer.value = copyListAnswer;
            });
        }

        function onAddAnswer() {
            listAnswer.value.push({
                key: "",
                right: QUIZ_NOT_CHECKED
            });

            // watch last item just added
            const lastItemNow = listAnswer.value.length - 1;
            watch(listAnswer.value[lastItemNow], newValue => {
                const copyListAnswer = [...listAnswer.value];
                copyListAnswer.splice(lastItemNow, 1, newValue); // change last item just added
                listAnswer.value = copyListAnswer;
            });
        }

        function onRemoveAnswer(index) {
            const copyListAnswer = [...listAnswer.value];
            copyListAnswer.splice(index, 1);
            listAnswer.value = copyListAnswer;

            if (answerChecked.value.length) {
                const copyAnswerChecked = [...answerChecked.value];
                for (let i = index + 1; i < copyAnswerChecked.length; i++) {
                    --copyAnswerChecked[i];
                }
                copyAnswerChecked.splice(index, 1);

                answerChecked.value = copyAnswerChecked;
            } else {
                if (answerChecked.value == index) {
                    answerChecked.value = "";
                }
            }

            // random lại key để re-render quill-editor
            listKeyAnswer.value = [];
            for (let i = 0; i < listAnswer.value.length; i++) {
                let keyRandom = `answer-${i + Math.random()}`;
                listKeyAnswer.value.push(keyRandom);
            }
        }

        return {
            QUIZ_CHECKED,
            listAnswer,
            listKeyAnswer,
            answerChecked,
            onAddAnswer,
            onRemoveAnswer
        };
    }
};
</script>
